package resume

import (
	"net/http"

	d "github.com/karincake/dodol"
	rw "github.com/karincake/risoles"
	sf "github.com/karincake/semprit"

	// ua "github.com/karincake/tumpeng/auth/svc"

	e "simrs-vx/internal/domain/main-entities/resume"
	u "simrs-vx/internal/use-case/main-use-case/resume"

	erc "simrs-vx/internal/domain/references/common"

	pa "simrs-vx/internal/lib/auth"
)

func Create(w http.ResponseWriter, r *http.Request) {
	authInfo, err := pa.GetAuthInfo(r)
	if err != nil {
		rw.WriteJSON(w, http.StatusUnauthorized, d.IS{"message": err.Error()}, nil)
	}
	dto := e.CreateDto{}
	if res := rw.ValidateStructByIOR(w, r.Body, &dto); !res {
		return
	}

	dto.AuthInfo = *authInfo
	res, err := u.Create(dto)
	rw.DataResponse(w, res, err)
}

func GetList(w http.ResponseWriter, r *http.Request) {
	dto := e.ReadListDto{}
	sf.UrlQueryParam(&dto, *r.URL)
	res, err := u.ReadList(dto)
	rw.DataResponse(w, res, err)
}

func GetDetail(w http.ResponseWriter, r *http.Request) {
	id := rw.ValidateInt(w, "id", r.PathValue("id"))
	if id <= 0 {
		return
	}
	dto := e.ReadDetailDto{}
	sf.UrlQueryParam(&dto, *r.URL)
	dto.Id = uint(id)
	res, err := u.ReadDetail(dto)
	rw.DataResponse(w, res, err)
}

func Update(w http.ResponseWriter, r *http.Request) {
	authInfo, err := pa.GetAuthInfo(r)
	if err != nil {
		rw.WriteJSON(w, http.StatusUnauthorized, d.IS{"message": err.Error()}, nil)
	}
	id := rw.ValidateInt(w, "id", r.PathValue("id"))
	if id <= 0 {
		return
	}

	dto := e.UpdateDto{}
	if res := rw.ValidateStructByIOR(w, r.Body, &dto); !res {
		return
	}
	dto.Id = uint(id)
	dto.AuthInfo = *authInfo
	res, err := u.Update(dto)
	rw.DataResponse(w, res, err)
}

func Delete(w http.ResponseWriter, r *http.Request) {
	authInfo, err := pa.GetAuthInfo(r)
	if err != nil {
		rw.WriteJSON(w, http.StatusUnauthorized, d.IS{"message": err.Error()}, nil)
	}
	id := rw.ValidateInt(w, "id", r.PathValue("id"))
	if id <= 0 {
		return
	}

	dto := e.DeleteDto{}
	dto.Id = uint(id)
	dto.AuthInfo = *authInfo
	res, err := u.Delete(dto)
	rw.DataResponse(w, res, err)
}

func Verify(w http.ResponseWriter, r *http.Request) {
	authInfo, err := pa.GetAuthInfo(r)
	if err != nil {
		rw.WriteJSON(w, http.StatusUnauthorized, d.IS{"message": err.Error()}, nil)
	}
	id := rw.ValidateInt(w, "id", r.PathValue("id"))
	if id <= 0 {
		return
	}

	dto := e.UpdateDto{}
	dto.Id = uint(id)
	dto.Status_Code = erc.DVCVerified
	dto.AuthInfo = *authInfo
	res, err := u.UpdateStatusCode(dto)
	rw.DataResponse(w, res, err)
}

func Validate(w http.ResponseWriter, r *http.Request) {
	authInfo, err := pa.GetAuthInfo(r)
	if err != nil {
		rw.WriteJSON(w, http.StatusUnauthorized, d.IS{"message": err.Error()}, nil)
	}
	id := rw.ValidateInt(w, "id", r.PathValue("id"))
	if id <= 0 {
		return
	}

	dto := e.UpdateDto{}
	dto.Id = uint(id)
	dto.Status_Code = erc.DVCValidated
	dto.AuthInfo = *authInfo
	res, err := u.UpdateStatusCode(dto)
	rw.DataResponse(w, res, err)
}
